/*
 * Copyright (c) 2015. Ncomz. All Rights Reserved
 */

package com.ntels.kneet.v3.view.things;

import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.widget.Toolbar;
import android.view.LayoutInflater;
import android.view.View;

import com.ntels.kneet.v3.common.AppConfig;
import com.ntels.kneet.v3.common.Constants;
import com.ntels.kneet.v3.common.db.SQLManager;
import com.ntels.kneet.v3.common.http.HttpSend;
import com.ntels.kneet.v3.common.http.Response;
import com.ntels.kneet.v3.common.c_interface.Main_Interface;
import com.ntels.kneet.v3.common.c_interface.OnDataSendToReslut;
import com.ntels.kneet.v3.common.util.Dlog;
import com.ntels.kneet.v3.common.util.Util;
import com.ntels.kneet.v3.common.widget.CustomActivity;
import com.ntels.kneet.v3.R;
import com.ntels.kneet.v3.view.dialog.CommonProgressDialog;
import com.ntels.kneet.v3.view.dialog.CustomDialog;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

public class Things_Device_Del_02 extends CustomActivity implements View.OnClickListener,
                                                                    CustomDialog.OnMsgAlterToResult {

    /*툴바 관련*/
    private Toolbar toolbar;

    /*통신 관련*/
    private              ArrayList<HashMap<String, Object>> alTotalList                                 = new ArrayList<HashMap<String, Object>>();
    private              int                                iType                                       = 0;
    private static final int                                MSG_COM_G_DEVICES_DEVICE_ID_COMMANDS_STATUS = 1;

    /*공통*/
    private Activity             act;
    private AppConfig            appConfig;
    private Main_Interface       mCallback;
    private Intent               intent;
    private CommonProgressDialog mDialog;
    private ScheduledFuture      scheduledFuture;
    private Util         util              = new Util();
    private CustomDialog customDialog      = new CustomDialog();
    private String       sCallType         = "";
    private SQLManager   sqlManager        = new SQLManager();
    private boolean      bReloadFinishFlag = false;
    private String       sDEVICE_NAME      = "";
    private String       sCOMPANY_NAME     = "";
    private String       sDEVICE_DESC1     = "";
    private int          iDEVICE_IMAGE1    = 0;
    private String       sGROUP_DEVICE     = "";
    private String       sDEVICE_DESC     = "";
    private String       sHTTP_command_id  = "";
    private Boolean      bEnd              = false;
    private Boolean      bCancel           = false;
    private Boolean      bPollingSend      = false;
    private Boolean      bPollingPause     = false;
    private Boolean      bPollingCancel    = false;
    private Boolean      bActStop          = false;
    private int          iMaxTime          = 60;
    private int          iTotal            = 0;

    @Override public void onStop() {

        super.onStop();
        Dlog.v("onStop()");
        //        bPollingPause = true;
        //        bActStop = true;
    }

    @Override public void onDestroy() {

        super.onDestroy();
        Dlog.v("onDestroy()");
        if ( scheduledFuture != null ) {
            scheduledFuture.cancel(false);
            bPollingPause = true;
        }
    }

    @Override public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);

        act = Things_Device_Del_02.this;
        appConfig = (AppConfig) act.getApplicationContext();
        customDialog.setOnMsgAlterToResultEvent(this);

        View viewToLoad = LayoutInflater.from(act).inflate(R.layout.things_device_del_02, null);
        this.setContentView(viewToLoad);

        if ( savedInstanceState != null ) {
            // sTitle =
            // savedInstanceState.getString(Constants.EXTRA_SPINNER_TITLE);
            // aList1 =
            // savedInstanceState.getStringArrayList(Constants.EXTRA_SPINNER_LIST1);
            // aList2 =
            // savedInstanceState.getStringArrayList(Constants.EXTRA_SPINNER_LIST2);
            // // 0: 세로 한개 선택, 1: 가로 한개선택
            // iType = savedInstanceState.getInt(Constants.EXTRA_SPINNER_TYPE,
            // 0);
            // sBtn1 =
            // savedInstanceState.getString(Constants.EXTRA_SPINNER_BTN1);
            // sBtn2 =
            // savedInstanceState.getString(Constants.EXTRA_SPINNER_BTN2);
            // iPosition =
            // savedInstanceState.getInt(Constants.EXTRA_SPINNER_POSITION, 0);
        } else {
            Intent intent = getIntent();
            //            sCallType = intent.getStringExtra(Constants.EXTRA_CALL_TYPE);
            sDEVICE_NAME = intent.getStringExtra(Constants.EXTRA_DEVICE_NAME);
            sGROUP_DEVICE = intent.getStringExtra(Constants.EXTRA_GROUP_DEVICE);
            sCOMPANY_NAME = intent.getStringExtra(Constants.EXTRA_COMPANY_NAME);
            sDEVICE_DESC1 = intent.getStringExtra(Constants.EXTRA_DEVICE_DESC1);
            iDEVICE_IMAGE1 = intent.getIntExtra(Constants.EXTRA_DEVICE_IMAGE1, 0);
            sHTTP_command_id = intent.getStringExtra(Constants.EXTRA_COMMAND_ID);
        }

        setDisp();
    }

    private void setDisp() {

        util.getView(act, R.id.llBtn1).setOnClickListener(this);
        util.getView(act, R.id.llPageRoot).setVisibility(View.VISIBLE);

        util.getTextView(act, R.id.tvDeviceDesc).setText(sDEVICE_DESC1);
        util.setImage(act, iDEVICE_IMAGE1, util.getImageView(act, R.id.ivIconDevice));
        setThingsAddPolling();
    }

    private void setThingsAddPolling() {

        iTotal = 0;
        Dlog.v("Things setThingsPolling");
        ScheduledExecutorService scheduler = Executors.newSingleThreadScheduledExecutor();

        bPollingPause = false;
        bPollingCancel = false;
        scheduledFuture = scheduler.scheduleAtFixedRate(runnable, 1, 1, TimeUnit.SECONDS);
    }

    Runnable runnable = new Runnable() {
        public void run() {

            Dlog.v("Things bPollingCancel", bPollingCancel);
            Dlog.v("Things bPollingPause", bPollingPause);
            if ( bPollingCancel ) {
                scheduledFuture.cancel(false);
            }
            if ( !bPollingPause ) {
                //                Dlog.v("Things iTotal", iTotal + "");
                iTotal++;
                util.getTextView(act, R.id.tvConnectTime).post(new Runnable() {
                    @Override public void run() {

                        util.getTextView(act, R.id.tvConnectTime).setText((iMaxTime - iTotal) + "");
                    }
                });
                //                Dlog.v("Things iTotal2", iTotal + "");
                if ( iTotal % 3 == 0 ) {
                    if ( !bPollingSend ) {
                        bPollingSend = true;
                        send_G_devices_device_id_commands_status();
                    }
                } else if ( iTotal >= iMaxTime ) {
                    if ( !bEnd ) {
                        bEnd = true;
                        util.getTextView(act, R.id.tvConnectTime).post(new Runnable() {
                            @Override public void run() {

                                util.getTextView(act, R.id.tvConnectTime).setText("");
                                intent = new Intent();
                                intent.putExtra(Constants.EXTRA_TIMEOUT_FLAG, true);
                                act.setResult(RESULT_CANCELED, intent);
                                finish();
                            }
                        });
                        scheduledFuture.cancel(false);
                    }
                }
            }
        }
    };

    @Override public void onConfigurationChanged(Configuration newConfig) {

        super.onConfigurationChanged(newConfig);
    }

    @Override public void onClick(View v) {

        switch (v.getId()) {
            case R.id.llBtn1:
                onBackPressed();
                break;
            default:
                break;
        }
    }
    @Override public void resultCustomDialogResponse(int iMsgID, int iBtnResult) {

        switch (iMsgID) {

            case Constants.MSG998:
                util.callApp_Start(act, "LOGOUT");
                break;
            case Constants.MSG997:
                util.callApp_Start(act, "HOME_RELOAD");
                break;
            case Constants.MSG807:
                if ( iBtnResult == 1 ) {
                    ComHandler.sendMessageDelayed(ComHandler.obtainMessage(iType), 10);
                }
                break;
            default:
                break;
        }
    }
    /**
     * <PRE>
     * 1. MethodName: onBackPressed
     * 2. ClassName :
     * 3. Comment   : 뒤로가기 버튼
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    @Override public void onBackPressed() {

        intent = new Intent();
        act.setResult(RESULT_CANCELED, intent);
        finish();
        return;
    }

    /**
     * <PRE>
     * 1. MethodName: onResume
     * 2. ClassName :
     * 3. Comment   : onResume
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    @Override public void onResume() {

        super.onResume();

        Dlog.v("onResume()");
        //        bPollingPause = false;
        //        bActStop = false;
    }

    Handler ComHandler = new Handler(new IncomingHandlerCallBack());

    class IncomingHandlerCallBack implements Handler.Callback {

        @Override public boolean handleMessage(Message msg) {

            iType = msg.what;
            switch (msg.what) {
                case MSG_COM_G_DEVICES_DEVICE_ID_COMMANDS_STATUS:
                    //dialog_show();
                    send_G_devices_device_id_commands_status();
                    break;
                default:
                    break;
            }
            return true;
        }
    }
    /**
     * <PRE>
     * 1. MethodName: send_G_devices_device_id_commands_status
     * 2. ClassName :
     * 3. Comment   : [Send][GET]하위 장치 추가/삭제 결과 조회 (Polling 용)(하위 장치의 추가/삭제 명령 결과를 조회한다.)
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    private void send_G_devices_device_id_commands_status() {

        try {
            HttpSend httpSend;

            httpSend = new HttpSend(act, false);

            httpSend.setOnDataSendToReslutEvent(new OnDataSendToReslut() {
                @Override public void resultResponse(Response result) {

                    result_G_devices_device_id_commands_status(result);
                }
            });
            httpSend.G_devices_device_id_commands_status(appConfig.sSelect_Homegrp_Homehub_Device_Id, sHTTP_command_id);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * <PRE>
     * 1. MethodName: result_G_devices_device_id_commands_status
     * 2. ClassName :
     * 3. Comment   : [Result][GET]하위 장치 추가/삭제 결과 조회 (Polling 용)(하위 장치의 추가/삭제 명령 결과를 조회한다.)
     * 4. Developer : 최진오
     * 5. Created   : 2015. 10.
     * </PRE>
     */
    private void result_G_devices_device_id_commands_status(Response rpResult) {

        try {
            if ( rpResult.getStatusCode() == 200 ) {
                JSONObject joResult = new JSONObject(rpResult.getContent());
                String sHTTP_status = util.null2string(joResult.get(Constants.HTTP_status));
                //                if ( !bCancel ) {
                if ( sHTTP_status.equals("EXC") ) {
                    scheduledFuture.cancel(false);
                    util.setPreferences(act, Constants.EXTRA_THINGS_ADD_REMOVE_TIME, "");
                    intent = new Intent(act, Things_Device_Del_03.class);
                    util.callActivityForResult(act, intent, Constants.ACT_THINGS_DEVICE_DEL_03);
                }
                //                }
            } else {
                JSONObject joResult = new JSONObject(rpResult.getContent());
                Dlog.v(joResult.toString());
                String sERR_CODE = util.null2string(joResult.get(Constants.HTTP_err_code));
                String sERR_MSG = util.null2string(joResult.get(Constants.HTTP_err_msg));

                if ( sERR_CODE.equals("401") ) {
                    if ( scheduledFuture != null ) {
                        scheduledFuture.cancel(false);
                    }
                    customDialog.MsgAlert(act, Constants.MSG998, sERR_MSG);
                } else if ( sERR_CODE.equals("401-106") ) {
                    if ( scheduledFuture != null ) {
                        scheduledFuture.cancel(false);
                    }
                    customDialog.MsgAlert(act, Constants.MSG997, sERR_MSG);
                } else {
                    customDialog.MsgAlert(act, Constants.MSG000, sERR_MSG);
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            customDialog.MsgAlert(act, Constants.MSG807);
        }
        bPollingSend = false;
    }

    @Override public void onActivityResult(int requestCode, int resultCode, Intent data) {

        super.onActivityResult(requestCode, resultCode, data);

        if ( resultCode == act.RESULT_OK ) {
            switch (requestCode) {
                case Constants.ACT_THINGS_DEVICE_DEL_03:
                    act.setResult(RESULT_OK, data);
                    finish();
                    break;
            }
        } else {
            //            switch (requestCode) {
            //                case Constants.ACT_THINGS_HOMEHUB_GUIDE_02:
            //                    Boolean bFlow_End_Flag = data.getBooleanExtra(Constants.EXTRA_FLOW_END_FLAG, false);
            //                    if ( bFlow_End_Flag ) {
            //                        act.setResult(RESULT_CANCELED, data);
            //                        finish();
            //                    } else {
            //                        util.getView(act, R.id.llPageRoot).setVisibility(View.VISIBLE);
            //                    }
            //                    break;
            //            }
        }
    }
}

